#!/usr/bin/env python
# -*- coding: utf-8 -*-
from roller_backdrop_acrylic_sky import AcrylicSky
from roller_backdrop_average_color import AverageColor
from roller_backdrop_back_game import BackGame
from roller_backdrop_clay_chemistry import ClayChemistry
from roller_backdrop_color_fill import ColorFill
from roller_backdrop_color_grid import ColorGrid
from roller_backdrop_core_design import CoreDesign
from roller_backdrop_crystal_cave import CrystalCave
from roller_backdrop_cube_pattern import CubePattern
from roller_backdrop_cubism_cover import CubismCover
from roller_backdrop_density_gradient import DensityGradient
from roller_backdrop_drop_zone import DropZone
from roller_backdrop_etch_sketch import EtchSketch
from roller_backdrop_floor_sample import FloorSample
from roller_backdrop_galactic_field import GalacticField
from roller_backdrop_glass_gaw import GlassGaw
from roller_backdrop_gradient_fill import GradientFill
from roller_backdrop_historic_trip import HistoricTrip
from roller_backdrop_image_gradient import ImageGradient
from roller_backdrop_line_stone import LineStone
from roller_backdrop_lost_maze import LostMaze
from roller_backdrop_maze_blend import MazeBlend
from roller_backdrop_mystery_grate import MysteryGrate
from roller_backdrop_nano_suit import NanoSuit
from roller_backdrop_noise_rift import NoiseRift
from roller_backdrop_paper_waste import PaperWaste
from roller_backdrop_pattern_fill import PatternFill
from roller_backdrop_rainbow_valley import RainbowValley
from roller_backdrop_rect_pattern import RectPattern
from roller_backdrop_rocky_landing import RockyLanding
from roller_backdrop_soft_touch import SoftTouch
from roller_backdrop_specimen_speckle import SpecimenSpeckle
from roller_backdrop_spiral_channel import SpiralChannel
from roller_backdrop_square_cloud import SquareCloud
from roller_backdrop_stone_age import StoneAge
from roller_backdrop_trailing_vine import TrailingVine
from roller_backdrop_roof_top import RoofTop
from roller_frame_nail_polish import NailPolish
from roller_frame_ball_joint import BallJoint
from roller_frame_border_line import BorderLine
from roller_frame_brush_punch import BrushPunch
from roller_frame_camo_planet import CamoPlanet
from roller_frame_ceramic_chip import CeramicChip
from roller_frame_circle_punch import CirclePunch
from roller_frame_clear_frame import ClearFrame
from roller_frame_color_board import ColorBoard
from roller_frame_color_pipe import ColorPipe
from roller_frame_corner_tape import CornerTape
from roller_frame_crumble_shell import CrumbleShell
from roller_frame_cutout_plate import CutoutPlate
from roller_frame_feather_step import FeatherStep
from roller_frame_frame_over import FrameOver
from roller_frame_gradient_level import GradientLevel
from roller_frame_hot_glue import HotGlue
from roller_frame_jagged_edge import JaggedEdge
from roller_frame_line_fashion import LineFashion
from roller_frame_link_mirror import LinkMirror
from roller_frame_paint_rush import PaintRush
from roller_frame_rad_wave import RadWave
from roller_frame_raised_maze import RaisedMaze
from roller_frame_shadow import Shadowy
from roller_frame_shape_burst import ShapeBurst
from roller_frame_square_cut import SquareCut
from roller_frame_square_punch import SquarePunch
from roller_frame_stained_glass import StainedGlass
from roller_frame_sticky_wobble import StickyWobble
from roller_frame_stretch_tray import StretchTray
from roller_frame_wire_fence import WireFence
from roller_constant_key import BackdropStyle as by, Frame as ek

# {Frame key: Frame Maya}
FRAME_D = {
    ek.BALL_JOINT: BallJoint,
    ek.BORDER_LINE: BorderLine,
    ek.BRUSH_PUNCH: BrushPunch,
    ek.CAMO_PLANET: CamoPlanet,
    ek.CERAMIC_CHIP: CeramicChip,
    ek.CIRCLE_PUNCH: CirclePunch,
    ek.CLEAR_FRAME: ClearFrame,
    ek.COLOR_BOARD: ColorBoard,
    ek.COLOR_PIPE: ColorPipe,
    ek.CORNER_TAPE: CornerTape,
    ek.CRUMBLE_SHELL: CrumbleShell,
    ek.CUTOUT_PLATE: CutoutPlate,
    ek.FEATHER_STEP: FeatherStep,
    ek.FRAME_OVER: FrameOver,
    ek.GRADIENT_LEVEL: GradientLevel,
    ek.HOT_GLUE: HotGlue,
    ek.JAGGED_EDGE: JaggedEdge,
    ek.LINE_FASHION: LineFashion,
    ek.LINK_MIRROR: LinkMirror,
    ek.NAIL_POLISH: NailPolish,
    ek.PAINT_RUSH: PaintRush,
    ek.RAD_WAVE: RadWave,
    ek.RAISED_MAZE: RaisedMaze,
    ek.SHAPE_BURST: ShapeBurst,
    ek.SQUARE_CUT: SquareCut,
    ek.SQUARE_PUNCH: SquarePunch,
    ek.STAINED_GLASS: StainedGlass,
    ek.STICKY_WOBBLE: StickyWobble,
    ek.STRETCH_TRAY: StretchTray,
    ek.SHADOWY: Shadowy,
    ek.WIRE_FENCE: WireFence
}

# {Backdrop Style key: Style Maya}
BACKDROP_STYLE_D = {
    by.ACRYLIC_SKY: AcrylicSky,
    by.AVERAGE_COLOR: AverageColor,
    by.BACK_GAME: BackGame,
    by.CLAY_CHEMISTRY: ClayChemistry,
    by.COLOR_FILL: ColorFill,
    by.COLOR_GRID: ColorGrid,
    by.CORE_DESIGN: CoreDesign,
    by.CRYSTAL_CAVE: CrystalCave,
    by.CUBE_PATTERN: CubePattern,
    by.CUBISM_COVER: CubismCover,
    by.DENSITY_GRADIENT: DensityGradient,
    by.DROP_ZONE: DropZone,
    by.ETCH_SKETCH: EtchSketch,
    by.FLOOR_SAMPLE: FloorSample,
    by.GALACTIC_FIELD: GalacticField,
    by.GLASS_GAW: GlassGaw,
    by.GRADIENT_FILL: GradientFill,
    by.HISTORIC_TRIP: HistoricTrip,
    by.IMAGE_GRADIENT: ImageGradient,
    by.LINE_STONE: LineStone,
    by.LOST_MAZE: LostMaze,
    by.MAZE_BLEND: MazeBlend,
    by.MYSTERY_GRATE: MysteryGrate,
    by.NANO_SUIT: NanoSuit,
    by.NOISE_RIFT: NoiseRift,
    by.PAPER_WASTE: PaperWaste,
    by.PATTERN_FILL: PatternFill,
    by.RAINBOW_VALLEY: RainbowValley,
    by.RECT_PATTERN: RectPattern,
    by.ROCKY_LANDING: RockyLanding,
    by.SOFT_TOUCH: SoftTouch,
    by.SPECIMEN_SPECKLE: SpecimenSpeckle,
    by.SPIRAL_CHANNEL: SpiralChannel,
    by.SQUARE_CLOUD: SquareCloud,
    by.STONE_AGE: StoneAge,
    by.TRAILING_VINE: TrailingVine,
    by.ROOF_TOP: RoofTop
}
